<?php
ini_set('display_errors', 1);

require_once '../../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["teacher"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

$institution_id = $postdata['institution_id'];
$branch_id = $postdata['branch_id'];

require_once $base_path_to_learning . 'functions/common_functions.php';
require_once $base_path_to_learning . 'functions/get_branch_functions.php';

// Validate institution_id and branch_id
$academicSessionId = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
if (!$academicSessionId) {
    errorreturn("Invalid institution_id");
}

$isBranchClassSubjectValid = checkBranchClassSubject($conn_rjllearning_specific, $branch_id, null, null, $institution_id);
if (!$isBranchClassSubjectValid) {
    errorreturn("Invalid branch_id.");
} 

function fetchDailyReceipts_ByCategory($category_id, $date, $conn_rjllearning_specific, $institution_id, $branch_id, $limit, $offset)
{
    $sql_session = "
        SELECT 
            date,category_id,amount
        FROM 
            unmarked_transaction
        WHERE 
            category_id = ? AND transaction_type_group = 'receipt' 
            AND date = ? AND institution_id = ?  
    ";

    $array_params = [$category_id, $date, $institution_id];

    if ($branch_id == 'all') {
        $sql_session .= "";
    } else if ($branch_id !=  null  && $branch_id != 'all') {
        $sql_session .= " AND branch_id = ? ";
        $array_params[] = $branch_id;
    }

    $sql_session .= "LIMIT " . $offset . " ," . $limit . "";

    $stmt = $conn_rjllearning_specific->prepare($sql_session);
    $stmt->execute($array_params);
    $session_rows = $stmt->fetchAll();

    $array_return = [];

    foreach ($session_rows as $rows) {
        $array_return[] = array(
            'date' => $rows['date'],
            'category_id' => $rows['category_id'],
            'amount' => $rows['amount'],
        );
    }

    if (count($session_rows) < 50) {
        return array( 'daily_reciepts_info' => $array_return, 'maxreach' => 1);
    } else {
        return array( 'daily_reciepts_info' => $array_return, 'maxreach' => 0);
    }
}


if ($postdata['function_type'] == "fetch_daily_reciepts") {

    $institution_id = trim($postdata['institution_id']);

    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }

    if (isset($postdata['branch_id']) and !empty($postdata['branch_id']) and trim($postdata['branch_id'])) {
        $branch_id = trim($postdata['branch_id']);
    } else {
        $branch_id = null;
    }

    $limit = $postdata['limit'];

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = fetchDailyReceipts_ByCategory($category_id, $date, $conn_rjllearning_specific, $institution_id, $branch_id, $limit, $offset);
        successreturn($success);
    } else {
        $success['data'] = fetchDailyReceipts_ByCategory($category_id, $date, $conn_rjllearning_specific, $institution_id, $branch_id, $limit, null);
        successreturn($success);
    }
}
